PImage image = loadImage("underwater_dog.bmp");
size(720, 500);
noStroke();
background(255);

String secretMessage = "";
long pixel = 0;
int numChars = 0;
int character = 0;
for (int y = 0; y < image.height; y++) {
  for (int x = 0; x < image.width; x++) {
    color c = image.get(x, y);
    int red = (int) red(c);
    int bit = red % 2;
    long byteNum = pixel / 8;  
    if (byteNum == 0) {
      // need to find the length of the message
      numChars += bit * pow(2, pixel % 8);
    } else if (byteNum <= numChars) {
      character += bit * pow(2, pixel % 8);
      if (pixel % 8 == 7) {
        secretMessage += ((char) character);
        character = 0;
      }
    }   
    pixel++;
  } 
}

fill(0);
textSize(36);
text(secretMessage, 30, 30, width - 50, height - 30);
